package file.sr;
import java.io.BufferedInputStream;
import java.io.IOException;


public class Pacote {
	
	
	private final int PACKET_SIZE=5000;
	private final int OVERHEAD_SIZE=9;
	private byte[] data;
	private int packetNumber;
	private int lastPacketSize;
	private byte isLastPacket;
	public int estado = 0;
	
	//0 - no autorizado
	//1 - autorizado, mas nao enviado
	//2 - enviado com ack pendente
	//3 - ja reconhecido
	
	public Pacote(int packetNumber, byte isLastPacket, int lastPacketSize, BufferedInputStream bis) throws IOException{
		if(isLastPacket==1){
			data = new byte[lastPacketSize+OVERHEAD_SIZE];
		}else{
		data = new byte[PACKET_SIZE+OVERHEAD_SIZE];
		}
		
		this.lastPacketSize = lastPacketSize;
		byte[] lastPacketSizeInBytes = intToByte(lastPacketSize);
		byte[] packetNumberInBytes = intToByte(packetNumber);
		this.isLastPacket=isLastPacket;
		this.packetNumber=packetNumber;
		data[0] = packetNumberInBytes[0];
		data[1] = packetNumberInBytes[1];
		data[2] = packetNumberInBytes[2];
		data[3] = packetNumberInBytes[3];
		data[4] = lastPacketSizeInBytes[0];
		data[5] = lastPacketSizeInBytes[1];
		data[6] = lastPacketSizeInBytes[2];
		data[7] = lastPacketSizeInBytes[3];
		data[8] = isLastPacket;
		
		if(isLastPacket==1){
			bis.read(data,OVERHEAD_SIZE,lastPacketSize);
		}else{
			bis.read(data,OVERHEAD_SIZE,PACKET_SIZE);
		}
		
	}
	
	public byte[] intToByte(int value) {
		return new byte[] { (byte) (value >>> 24), (byte) (value >>> 16),
				(byte) (value >>> 8), (byte) value };
	}
	
	public byte[] getData(){
		return data;
	}
	
	public int getPacketNumber(){
		return packetNumber;
	}
	
	public int getLastPacketSize(){
		return lastPacketSize;
	}
	
	public byte getIsLastPacket(){
		return isLastPacket;
	}
}
